//Funcao responsavel por fazer o parse dos dados da noticia passados como parametro atraves da chamada da url
function parseQueryString(queryString) {
	if (typeof (queryString) != 'string') {
		return queryString;
	}

	if (queryString[0] == '?') {
		queryString = queryString.substring(1, queryString.length);
	}

	var params = {}, queries, temp, i, l;
	queries = queryString.split('&');

	for (i = 0, l = queries.length; i < l; i++) {
		temp = queries[i].split('=');
		params[temp[0]] = temp[1];
	}
	return params;
}

//Funcao responsavel por exibir os dados da noticia no template
function loadNews(imgVar, txtVar) {
	if (imgVar) {
		var urlImg = imgVar;
		var match = urlImg.substring(urlImg.lastIndexOf('/') + 1);
		/* if (match != '0.png') {
			document.getElementById('imgVar').src = imgVar;
		} */
	}
	if (txtVar) {
		var options = parseQueryString(decodeURIComponent(decodeURIComponent(txtVar)));
		if (options.latitude) {
			latitude = Number(options.latitude);
		}
		if (options.longitude) {
			longitude = Number(options.longitude);
		}
		if (options.chave) {
			chave = options.chave;
		}
		if (options.zoom) {
			zoom = Number(options.zoom);
		}
		if (options.tempo_noticia) {
			tempo_noticia = Number(options.tempo_noticia) * 1000;
		}
		function loadScript() {
			var script = document.createElement('script');
			script.type = 'text/javascript';
			script.src = `https://maps.googleapis.com/maps/api/js?key=${chave}&callback=initMap&libraries=&v=weekly`
			document.body.appendChild(script);
		}
		window.onload = loadScript;
	}
}

function loadData(data) {
	variables = data.variables;

	if (variables.latitude) {
		latitude = Number(variables.latitude);
	}
	if (variables.longitude) {
		longitude = Number(variables.longitude);
	}
	if (variables.chave) {
		chave = variables.chave;
	}
	if (variables.zoom) {
		zoom = Number(variables.zoom);
	}
	if (variables.tempo_noticia) {
		tempo_noticia = Number(variables.tempo_noticia) * 1000;
	}
	if (chave) {
		var script = document.createElement('script');
		script.type = 'text/javascript';
		script.src = `https://maps.googleapis.com/maps/api/js?key=${chave}&callback=initMap&libraries=&v=weekly`
		document.body.appendChild(script);
	}
}

function dynamicContent() {
	const contentControl = new ContentControl();
	contentControl.on('ready', (data) => {
		const news = data.content;
		loadData({ variables: news.variables });
		contentControl.start();
	});
	contentControl.run();
}

const urlParams = new URLSearchParams(window.location.search);

if (urlParams.get('dynamic-content') == undefined) {
	const options = parseQueryString(decodeURIComponent(window.location.search));
	loadNews(options.imgVar, options.txtVar);
	setInterval(function () { nextNews() }, tempo_noticia);
	setTimeout(function () { Android.finish(); }, tempo_noticia);
}

window.addEventListener('contentload', () => {
	if (window.ContentControl) {
		dynamicContent();
	}
});

// API Google Maps
function initMap() {
	map = new google.maps.Map(document.getElementById("map"), {
		center: { lat: latitude, lng: longitude },
		zoom: zoom,
		disableDefaultUI: true
	});

	var trafficLayer = new google.maps.TrafficLayer();
	trafficLayer.setMap(map);

	var marker = new google.maps.Marker({
		position: { lat: latitude, lng: longitude },
		map: map,
	});

	map.addListener('center_changed', function () {
		window.setTimeout(function () {
			map.panTo(marker.getPosition());
		}, 10000);
	});
}

function nextNews() {
	window.AreaInterface.nextNews();
}
